PROGRAM_NAME='Infocomm06_1.4'

//THIS PROGRAM WAS WRITTEN AND TESTED BY THE MANUFACTURER

//PLEASE READ THE MODULE HELP DOCUMENT LOCATED IN THE DIRECTORY!!!  THIS FILE IS ALSO MAPPED IN THE NETLINX STUDIO "OTHER" TREE

//INFOCOMM_2006 FILE SHOWS EXAMPLE OF CONTROL ON NEARLY ALL PROCESSING OBJECTS

//SEE 'BSS BASIC EXAMPLE AND ROOM_COMBINE' FILE FOR SPECIFIC EXAMPLE ON CONTROLLING THE ROOM_COMBINE PO
//AND FOR TRUE FEEDBACK GAIN FADER EXAMPLES


//SE 4/15/08

(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

dvSOUNDWEB=5001:1:0 //real device RS232 port 1
dvTP = 10001:1:0


(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

//MUST ASSIGN [NODE <2 BYTES>, VD <1 BYTE>, OBJECT ID <3BYTES>] (ALWAYS 6 BYTES) FOR EVERY REAL OR VIRTUAL DEVICE!!!!
//GET THIS BY COPY AND PASTING FROM PROPERTIES WINDOW IN LONDON ARCHITECTURE (SEE HELP FILE FOR MORE INFO)
CHAR IO_CARD1[] = {$08,$1A,$03,$00,$00,$01};// I/O CARD SLOT A IS ALWAYS OBJECT ID $00,$00,$01
CHAR IO_CARD2[] = {$08,$1A,$03,$00,$00,$02};// I/O CARD SLOT B IS ALWAYS OBJECT ID $00,$00,$02
CHAR IO_CARD3[] = {$08,$1A,$03,$00,$00,$03};// I/O CARD SLOT C IS ALWAYS OBJECT ID $00,$00,$03
CHAR IO_CARD4[] = {$08,$1A,$03,$00,$00,$04};// I/O CARD SLOT D IS ALWAYS OBJECT ID $00,$00,$04


CHAR CHAP_AUTO[] =    {$08,$1A,$03,$00,$01,$02}; //AUTOMIXER DEVICE IN LONDON ARCHITECTURE
CHAR BR_MIC_MIXER[] = {$08,$1A,$03,$00,$01,$24}; //MIXER 
CHAR MR_MIC_MIXER[] = {$08,$1A,$03,$00,$01,$23};//MIXER
CHAR VIDEO_SERVER[] = {$08,$1A,$03,$00,$01,$33};//ROUTER
CHAR MICS[] =         {$08,$1A,$03,$00,$01,$34};//MATRIX MIXER
CHAR WC_GAIN[] =      {$08,$1a,$03,$00,$01,$0A}; //GAIN OBJECT
CHAR RED_ROOMGAIN[] = {$08,$1a,$03,$00,$01,$00}; //N-GAIN OBJECT
CHAR SYSTEM_MATRIX[] ={$08,$1A,$03,$00,$01,$01}; //SOURCE_MATRIX
CHAR BRIEFING_ROOM[] ={$08,$1A,$03,$00,$01,$35}; //SOURCE_SELECTOR


INTEGER GAIN_STEP_PER = 1; //GAIN STEP IF USING SET_GAIN_PERCENT
INTEGER MAX_RAMPGAIN_PER = 100; //THESE ARE VALUES USING SUBSCRIBE%
INTEGER MIN_RAMPGAIN_PER = 0;


(**************** STRING FORMATING CONSTANTS ******************************************** *)
STX = $02; ETX = $03;
ACK = $06; NAK = $15;
ESC = $1B; //ESCAPE CHAR
ET = $88; //EVENT
(******************************************************************************************)

(*******************  DEVICE AND PARAMETER CONSTANTS - MUST KEEP ***************************************************)
(*******************************************************************************************************************)
//THESE CONSTANTS ARE USED FOR 'FRIENDLY' PARAMETER FUNCTION CALLS. 
//SEE EXAMPLE PROGRAM BELOW FOR USE.  SEE HELP FILE FOR ADDITIONAL EXAMPLES
 
(*  DEVICE CONSTANTS FOR <DEVICE> FUNCTION PARAMETER *)
AUTOMIXER = 1; MIXER = 2;MM = 4; ROUTER =6; METER = 7; SOURCE_SELECTOR = 8; SOURCE_MATRIX = 9;
N_GAIN = 10; INPUT_CARD = 11; OUTPUT_CARD = 12; ROOM_COMBINE = 26;

(* PARAMETER CONSTANTS <PARAM> FUNCTION PARAMETER  *)
UNMUTE = 0; MUTE = 1; ROUTE = 1; GAIN = 3;UNROUTE = 0;  
POLARITY_ON = 1; POLARITY_OFF = 0;

(* PARAMETER CONSTANTS SPECIFICALLY FOR 'SET_MIXER' <PARAM> FUNCTION PARAMETER  *)
SOLO= 13;GROUP = 14;AUX = 15; OVERRIDE = 16; AUTO = 17; AUX_GAIN = 18; 
PAN = 19; OFF_GAIN = 20;GROUP_GAIN = 21; 

(* PARAMETER CONSTANTS SPECIFICALLY FOR 'SET_ROOMCOMBINE' <PARAM> FUNCTION PARAMETER  *)
SOURCE_MUTE = 30; BGM_MUTE = 31; MASTER_MUTE = 32; SOURCE_GAIN = 33; BGM_GAIN = 34; MASTER_GAIN = 35, BGM_SELECT = 36; 
PARTITION = 37;

(* PARAMETER CONSTANTS SPECIFICALLY FOR 'SET_PRESET' <PARAM> FUNCTION PARAMETER  *)
DEVICE_PRESET = 1; PARAMETER_PRESET = 2; 

(* PARAMETER CONSTANTS ONLY WHEN <DEVICE> == INPUT_CARD || OUTPUT_CARD *)
//GAIN IS ALSO VALID BUT ALREADY DEFINED ABOVE
PHANTOM = 22; REFERENCE = 23; ATTACK = 24; RELEASED = 25;

(* GENERAL FORMAT CONSTANTS *)
A=1;B=2;C=3;D=4; //INPUT_CARD DENOTIONS 
L = 1; R = 3;//LEFT CHANNEL, RIGHT CHANNEL FOR MIXERS/AUTOMIXERS
(*******************************************************************************************************************)
(*******************************************************************************************************************)



INTEGER GAIN_STEP_PER = 1; //GAIN STEP IF USING SET_GAIN_PERCENT
INTEGER MAX_RAMPGAIN_PER = 100; //THESE ARE VALUES USING SUBSCRIBE%
INTEGER MIN_RAMPGAIN_PER = 0;

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE INTEGER bDEBUG_FLAG 
VOLATILE CHAR cBUFFER[1000] //COMM PORT BUFFER
VOLATILE INTEGER nAttempts= 0     // counts the number of times we iterate before we should have received a full message
VOLATILE INTEGER STARTUP; //FLAG USED IN DEFINE_START ROUTINE
VOLATILE INTEGER T; //NUMBER OF TIMES 'SUBSCRIBE' OR 'SUBSCRIBE %' CALLED FROM DATA_EVENT:ONLINE.  USED FOR FB[] <FEEDBACK> ARRAY POPULATING IN SUBSCRIBE AND SUBSCRIBE% FOR TRUE FEEDBACK PURPOSES
VOLATILE INTEGER iGAIN_FRACTION; //USED IN PROCESS FEEDBACK FOR ROUNDING PURPOSES ON SET_GAIN%

//SEE HELP FILE FOR COMPLETE DESCRIPTION OF FB[][]
CHAR FB[200][12]; //FEEDBACK ARRAY - MUST MANUALLY ASSIGN DIMENSION OF ROWS[1] IF OVER 200 VARIABLES ARE USED FOR TRUE FEEDBACK (ie MAKE LARGER IF NEEDED); COLUMN[2] MUST ALWAYS BE 12!!


(* SAMPLE MATRIX ROUTING USED IN BUTTON_EVENT *)
INTEGER MATRIX_INPUT;
INTEGER MATRIX_OUTPUT;

(* SAMPLE PROGRAMMING CONTROLLING AUTOMIXER GAINS *)
INTEGER RAMP_GAIN_PER; //RAMP_GAIN IN PERCENT <0-100>
INTEGER MASTEROUT_VOL; //KEEP TRACK OF MASTEROUT VOLUME

INTEGER BARGRAPH; //LINKS BARGRAPH VALUE IN LEVEL_EVENT TO INC/DEC IN BUTTON_EVENT

(* SAMPLE USED IN DEFINE_PROGRAM FOR UPDATING VOLUME BAR GRAPHS *)
CHAR VOLUME[4];
LONG intVOL;
INTEGER MYVOL;

(*SUBSCRIBING TO A METER USING SUBSCRIBE%. UPDATING TO BARGRAPH IN DEFINE_PROGRAM *)
INTEGER METER_FB;
LONG intMETER_FB;
INTEGER myMETER;

INTEGER GAIN_BARGRAPH;

INTEGER MMIX[8][8];
INTEGER MMIX_IN;
INTEGER MMIX_OUT;
INTEGER MMIX_FB;
INTEGER MMIX_VOL[8];

INTEGER MROUT[4][4];
INTEGER SMAT[8][8];
INTEGER SMAT_IN;
INTEGER SMAT_OUT;
INTEGER SMAT_FB;

INTEGER menuOUTPUTCARD;
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
([dvTP,23]..[dvTP,30])
([dvTP,143]..[dvTP,150])

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)
DEFINE_CALL 'SET_VAL'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM,INTEGER VALUE)
{ 
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW;//LOW BYTE OF S_V
    LOCAL_VAR INTEGER S_VHIGH;//HIGH BYTE OF S_V
    LOCAL_VAR CHAR MY_DATA[4]; //FOUR BYTE DATA FIELD THAT HOLDS THE VALUE OF THE S_V
    LOCAL_VAR CHAR MY_STRING[13];//COMPLETE MESSAGE BEFORE BEING PADDED WITH STX,CHECKSUM,ETX, AND SPECIAL CHAR SUBSITUTION
    LOCAL_VAR CHAR EVENT; //DETERMINES DATA TYPE FOR S_V
    LOCAL_VAR CHAR GET_EVENT;//DETERMINES DATA TYPE FOR GET S_V
    
    IF(DEVICE = OUTPUT_CARD || DEVICE = INPUT_CARD)
    {
	EVENT = $8D;  // FOR SENDING PERCENT VALUES
	GET_EVENT = $8E;//FOR GETTING PERCENT VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "0,VALUE,0,0"; //when using percent only 2nd Data byte is utilized for range 0-100
    }
    ELSE
    {
	EVENT = $88; //FOR SENDING DISCRETE VALUES
	GET_EVENT = $89; //FOR GETTING DISCRETE VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "$00,$00,$00,VALUE"; //when using discrete the only value is 0 or 1 (on/off)
    }
    
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)
    
    //THESE STATEMENTS ARE ESSENTIALLY A 'GET' STATEMENT.  AFTER SENDING STRING GET_VALUE.
    MY_STRING = "GET_EVENT,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00";
    CALL 'CHECKSUM'(MY_STRING) //GET_FUNCTION FOR FEEDBACK
}

DEFINE_CALL 'SET_MIXER'(CHAR OBJECT[6], INTEGER INPUT, INTEGER OUTPUT, INTEGER PARAM, INTEGER VALUE)
//                  OBJECT = NODE+VD+OBJECT;PARAM = MUTE, SOLO, AUX, GROUP,OVERRIDE,AUTO,AUX ;VALUE = MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
{
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW;//LOW BYTE OF DATA
    LOCAL_VAR INTEGER S_VHIGH;//HIGH BYTE OF DATA
    LOCAL_VAR INTEGER DEVICE;//SPECIFIES TYPE OF DEVICE BEING PASSED TO 'GET_SV' 
    LOCAL_VAR CHAR MY_DATA[4]; 
    LOCAL_VAR LONG MY_PERCENT;
    LOCAL_VAR CHAR MY_STRING[13];
    LOCAL_VAR CHAR EVENT; 
    LOCAL_VAR CHAR GET_EVENT;//DETERMINES DATA TYPE FOR GET S_V

    DEVICE = MIXER;
    IF(PARAM = PAN || PARAM = OFF_GAIN || PARAM = AUX_GAIN || PARAM = GROUP_GAIN)
    {
	EVENT = $8D; //FOR SENDING PERCENT VALUES
	GET_EVENT = $8E;//FOR GETTING PERCENT VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "0,VALUE,0,0";
    }
    ELSE
    {
	EVENT = $88; //FOR DISCRETE VALUES
	GET_EVENT = $8E;//FOR GETTING PERCENT VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "$00,$00,$00,VALUE";
    }
    
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)
    
    //THESE STATEMENTS ARE ESSENTIALLY A 'GET' STATEMENT.  AFTER SENDING STRING GET_VALUE.
    //GET_FUNCTION FOR FEEDBACK
    MY_STRING = "GET_EVENT,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00";
    CALL 'CHECKSUM'(MY_STRING)
}

DEFINE_CALL 'SET_ROOMCOMBINE'(CHAR OBJECT[6], INTEGER INPUT, INTEGER OUTPUT, INTEGER PARAM, INTEGER VALUE)
//           OBJECT = NODE+VD+OBJECT;PARAM = SOURCE_GAIN,BGM_GAIN, MASTER_GAIN, SOURCE_MUTE, BGM_MUTE, MASTER_MUTE,BGM_SELECT, ;VALUE = MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0> FOR DISCRETES; 0-100 <PERCENT> FOR GAINS; 0-# OF BGM INPUTS FOR BGM_SELECT
{
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW;//LOW BYTE OF DATA
    LOCAL_VAR INTEGER S_VHIGH;//HIGH BYTE OF DATA
    LOCAL_VAR INTEGER DEVICE;
    LOCAL_VAR CHAR MY_DATA[4]; 
    LOCAL_VAR LONG MY_PERCENT;
    LOCAL_VAR CHAR MY_STRING[13];
    LOCAL_VAR CHAR EVENT; 

    DEVICE = ROOM_COMBINE;
    IF(PARAM = SOURCE_GAIN || PARAM = BGM_GAIN || PARAM = MASTER_GAIN )
    {
	EVENT = $8D; //FOR SENDING PERCENT VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "0,VALUE,0,0";
    }
    ELSE
    {
	EVENT = $88; //FOR DISCRETE VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "$00,$00,$00,VALUE";
    }
    
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)
    
    //THESE STATEMENTS ARE ESSENTIALLY A 'GET' STATEMENT.  AFTER SENDING STRING GET_VALUE.
    //GET_FUNCTION FOR FEEDBACK
    IF (EVENT = $88) //DISCRETE
	MY_STRING = "$89,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00";
    ELSE //PERCENT
	MY_STRING = "$8E,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00";

    CALL 'CHECKSUM'(MY_STRING)	    

}

DEFINE_CALL 'SET_GAIN'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT, SLONG VALUE)
{                  //  OBJECT = NODE+VD+OBJECT; DEVICE = MM <MANUAL MIXER>,AUTOMIXER, MIXER, GAIN<ENTER 0 IN INPUT AND OUTPUT FIELD TO SPECIFY SINGLE CHANNEL GAIN DEVICE>, N_GAIN :VALUE = -300,000 <-> 100,000
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW; //LOW BYTE OF DATA 
    LOCAL_VAR INTEGER S_VHIGH; //HIGH BYTE OF DATA
    LOCAL_VAR CHAR MY_DATA[4]; //DATA VALUE
    LOCAL_VAR INTEGER GAIN_A[4]; //CREATE ARRAY TO RETURN LONG GAIN BYTES BY_REF
    LOCAL_VAR CHAR MY_STRING[13]; 
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR INTEGER PARAM;
    
    EVENT = $88;
    PARAM = GAIN;
    
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    CALL 'SLONG_BYTES'(VALUE,GAIN_A)
    MY_DATA = "GAIN_A[1],GAIN_A[2],GAIN_A[3],GAIN_A[4]"; //MUST CONVERT INTO RECEIVING TYPE
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)
}

DEFINE_CALL 'SET_GAIN%'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT, INTEGER PERCENT) //1% = 1/3dB
{                  //  OBJECT = NODE+VD+OBJECT, DEVICE = MM <MANUAL MIXER>,AUTOMIXER, MIXER, GAIN<ENTER 0 IN INPUT AND OUTPUT FIELD TO SPECIFY SINGLE CHANNEL GAIN DEVICE>, N_GAIN :PERCENT = 0.0 - 100.0
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR MY_DATA[4]; //DATA VALUE
    LOCAL_VAR INTEGER GAIN_A[4]; //CREATE ARRAY TO RETURN LONG GAIN BYTES BY_REF
    LOCAL_VAR CHAR MY_STRING[13]; 
    LOCAL_VAR LONG MY_PERCENT;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR INTEGER PARAM;
    
    EVENT = $8D; //Set_Percent
    PARAM = GAIN;
    
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    MY_DATA = "0,PERCENT,0,0"
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)

    //THESE STATEMENTS ARE ESSENTIALLY A 'GET' STATEMENT.  AFTER SENDING STRING GET_VALUE.
    //UNCOMENT NEXT TWO LINES IF THE PROGRAMMER WISHES TO RECEIVE A RESPONSE TO EVERY GAIN STRING SENT.
    //MY_STRING = "$8E,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00"; //$8E Get_Percent
    //CALL 'CHECKSUM'(MY_STRING) //GET_FUNCTION FOR FEEDBACK

}


DEFINE_CALL 'SET_PRESET'(INTEGER PRESET_TYPE,INTEGER PRESET_NUMBER)
{
LOCAL_VAR CHAR SEND[10];
LOCAL_VAR CHAR EVENT;
    
    IF(PRESET_TYPE = PARAMETER_PRESET)
	EVENT = $8C;
    ELSE IF (PRESET_TYPE = DEVICE_PRESET)
	EVENT = $8B;
    ELSE //ERROR MESSAGE TO CONSOLE
	SEND_COMMAND 0,"'BSS_ERROR: Set_Preset - PARAM TYPE NOT FOUND.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
    
    SEND = "EVENT,$0,$0,$0,PRESET_NUMBER";
    CALL 'CHECKSUM'(SEND)

}
DEFINE_CALL 'SUBSCRIBE'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //CALL THIS IF YOU WANT LONDON TO SEND PARAMETER UPDATES
{  //                  OBJECT = NODE+VD+OBJECT, SV = STATE VAR; PARAM = GAIN <3>,MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
    LOCAL_VAR INTEGER S_V;
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR MY_DATA[4];
    LOCAL_VAR CHAR MY_STRING[13];

    
    EVENT = $89; //EVENT FOR SUBSCRIBE REGULAR
	
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    
    IF (PARAM = METER)
	PARAM =100;//METER SUBSCRIPTION RATE
    ELSE
	PARAM = 0;//ALL OTHER TYPES MUST HAVE DATA = 0 WHEN SUBSCRIBING
	
    MY_DATA = "$00,$00,$00,PARAM"; //SUBSCRIBE MESSAGE WITH 100ms <ONLY FOR METERS>
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    
    IF (STARTUP) //IF CALLED FROM STARTUP EVENT.  THESE ARE VARIABLES YOU WANT TO PARSE FEEDBACK FOR.  
    {
	T = T+1; //GLOBAL
	FB[T] = "OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    }
    CALL 'CHECKSUM'(MY_STRING)//SEND SUBSCRIBE MESSAGE
}

DEFINE_CALL 'SUBSCRIBE%'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //CALL THIS IF YOU WANT LONDON TO SEND PARAMETER UPDATES
{  //                  OBJECT = NODE+VD+OBJECT, SV = STATE VAR; PARAM = GAIN <3>,MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
    LOCAL_VAR INTEGER S_V;
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR MY_RATE[4];
    LOCAL_VAR CHAR MY_STRING[13];
    
    EVENT = $8E; //EVENT FOR SUBSCRIBE PERCENT
	
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    
    IF (PARAM == METER)
	PARAM =100;
    ELSE
	PARAM = 0;
	
    MY_RATE = "$00,$00,$00,PARAM"; //SUBSCRIBE MESSAGE WITH 100ms ONLY FOR METERS
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    
    IF (STARTUP) //IF CALLED FROM STARTUP EVENT.  THESE ARE VARIABLES YOU WANT TO PARSE FEEDBACK FOR.
    {
	T = T+1; //GLOBAL
	FB[T] = "OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    }
    CALL 'CHECKSUM'(MY_STRING)//SEND SUBSCRIBE MESSAGE
}

DEFINE_CALL 'UN_SUBSCRIBE'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //CALL THIS IF YOU WANT LONDON TO SEND PARAMETER UPDATES
{  //                  OBJECT = NODE+VD+OBJECT, SV = STATE VAR; PARAM = GAIN <3>,MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
    LOCAL_VAR INTEGER S_V;
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR MY_RATE[4];
    LOCAL_VAR CHAR MY_STRING[13];
    
    EVENT = $8A; //EVENT FOR UN_SUBSCRIBE REGULAR
	
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    
    IF (PARAM = METER)
	PARAM =100;
    ELSE
	PARAM = 0;
	
    MY_RATE = "$00,$00,$00,PARAM"; //SUBSCRIBE MESSAGE WITH 100ms ONLY FOR METERS
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    IF (STARTUP) //IF CALLED FROM STARTUP_EVENT (OR DATA_EVENT:ONLINE).  THESE ARE VARIABLES YOU WANT TO PARSE FEEDBACK FOR.
    {
	T = T+1; //GLOBAL
	FB[T] = "OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    }
    CALL 'CHECKSUM'(MY_STRING)//SEND SUBSCRIBE MESSAGE//SEND SUBSCRIBE MESSAGE
    

}

DEFINE_CALL 'UN_SUBSCRIBE%'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //CALL THIS IF YOU WANT LONDON TO SEND PARAMETER UPDATES
{  //                  OBJECT = NODE+VD+OBJECT, SV = STATE VAR; PARAM = GAIN <3>,MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
    LOCAL_VAR INTEGER S_V;
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR MY_RATE[4];
    LOCAL_VAR CHAR MY_STRING[13];

    
    EVENT = $8F; //EVENT FOR UN_SUBSCRIBE PERCENT

	
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    PARAM = 0;
    MY_RATE = "$00,$00,$00,PARAM"; //SUBSCRIBE MESSAGE WITH 100ms ONLY FOR METERS
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    
    IF (STARTUP) //IF CALLED FROM STARTUP_EVENT (OR DATA_EVENT:ONLINE).  THESE ARE VARIABLES YOU WANT TO PARSE FEEDBACK FOR.
    {
	T = T+1; //GLOBAL
	FB[T] = "OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    }
    
    CALL 'CHECKSUM'(MY_STRING)//SEND SUBSCRIBE MESSAGE//SEND SUBSCRIBE MESSAGE
    
}

DEFINE_CALL 'CHECKSUM'(CHAR MY_STRING[13]) //CALCULATE CHECKSUM AND SEND STRING
{
LOCAL_VAR CHAR SEND[26];
LOCAL_VAR INTEGER I;
LOCAL_VAR CHAR CS;
    
    SEND = ""; CS = 0;
    
    FOR (I=1;I <= LENGTH_ARRAY(MY_STRING);I++)
    {
	CS = (CS BXOR MY_STRING[I]); //CHECKSUM;
	
	IF (IS_SPECIAL(MY_STRING[I])) //CHECK FOR SPECIAL CHARS
	    SEND = "SEND,$1B,(MY_STRING[I]+128)"; //CONCATENATE ESCAPE CHAR AND SPECIAL CHAR
	ELSE
	    SEND = "SEND,MY_STRING[I]";
        
    } 
    
    IF(IS_SPECIAL(CS))//CHECK TO MAKE SURE CALCULATED CHECKSUM IS NOT A SPECIAL CHAR
	SEND = "STX,SEND,$1B,(CS+128),ETX";
    ELSE
	SEND = "STX,SEND,CS,ETX";
	
    SEND_STRING dvSOUNDWEB, SEND;

	//IF(bDEBUG_FLAG==2) // if full debug ON, print everything...
	    //fnLOG_HEX(SEND,LENGTH_STRING(SEND),'--> SENT')
}

DEFINE_CALL 'SLONG_BYTES'(SLONG intGAIN, INTEGER GAIN_A[4]) //TAKES SLONG AND RETURNS INTEGER 32BIT VALUE IN 4 CHAR CHARACTERS
{
    LOCAL_VAR INTEGER INT;
    LOCAL_VAR INTEGER HINT;
    LOCAL_VAR LONG LINT;
    LOCAL_VAR INTEGER LHI_BYTE;
    LOCAL_VAR INTEGER LLO_BYTE;
    LOCAL_VAR INTEGER ULO_BYTE;
    LOCAL_VAR INTEGER UHI_BYTE;
    
    INT = TYPE_CAST(intGAIN); //GET LOW 16 BITS FROM SLONG
    LINT = TYPE_CAST(intGAIN); //GET UPPER 16 BITS FROM SLONG
    LHI_BYTE = HI_BYTE(INT); //LOWER HI_BYTE
    LLO_BYTE = LO_BYTE(INT); //LOWER LO_BYTE
    
    LINT = LINT >> 16;
    HINT = TYPE_CAST(LINT)
    UHI_BYTE = HI_BYTE(HINT); //UPPER HI_BYTE
    ULO_BYTE = LO_BYTE(HINT); //UPPER LO_BYTE
    
    GAIN_A[1] = UHI_BYTE; //GAIN_A IS THE RETURN ARRAY OF VALUES BY_REF
    GAIN_A[2] = ULO_BYTE;
    GAIN_A[3] = LHI_BYTE;
    GAIN_A[4] = LLO_BYTE;
}

DEFINE_CALL 'LONG_BYTES'(LONG intGAIN, INTEGER GAIN_A[4]) //TAKES LONG AND RETURNS INTEGER 32BIT VALUE IN 4 CHAR CHARACTERS
{
    LOCAL_VAR INTEGER INT;
    LOCAL_VAR INTEGER HINT;
    LOCAL_VAR LONG LINT;
    LOCAL_VAR INTEGER LHI_BYTE;
    LOCAL_VAR INTEGER LLO_BYTE;
    LOCAL_VAR INTEGER ULO_BYTE;
    LOCAL_VAR INTEGER UHI_BYTE;
    
    INT = TYPE_CAST(intGAIN); //GET LOW 16 BITS FROM SLONG
    LINT = TYPE_CAST(intGAIN); //GET UPPER 16 BITS FROM SLONG
    LHI_BYTE = HI_BYTE(INT); //LOWER HI_BYTE
    LLO_BYTE = LO_BYTE(INT); //LOWER LO_BYTE
    
    LINT = LINT >> 16;
    HINT = TYPE_CAST(LINT)
    UHI_BYTE = HI_BYTE(HINT); //UPPER HI_BYTE
    ULO_BYTE = LO_BYTE(HINT); //UPPER LO_BYTE
    
    GAIN_A[1] = UHI_BYTE; //GAIN_A IS THE RETURN ARRAY OF VALUES BY_REF
    GAIN_A[2] = ULO_BYTE;
    GAIN_A[3] = LHI_BYTE;
    GAIN_A[4] = LLO_BYTE;
}

DEFINE_CALL 'PROCESS_FEEDBACK'(CHAR RECEIVED_STRING[13])
{
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR NODE[2];
    LOCAL_VAR CHAR VD;
    LOCAL_VAR CHAR OBJECT[3];
    LOCAL_VAR CHAR SV[2];
    LOCAL_VAR CHAR MY_DATA[4];
    LOCAL_VAR CHAR RECEIVED[13]; //TEST
    LOCAL_VAR INTEGER I,J; //COUNTERS
    LOCAL_VAR CHAR CS; //CHECKSUM
    STACK_VAR INTEGER INDEX //DEBUG
    STACK_VAR CHAR HEX_DATA[100] // MAX SIZE


    EVENT = TYPE_CAST(LEFT_STRING(RECEIVED_STRING,1)); 
(*//DEBUG
    NODE = MID_STRING(RECEIVED_STRING,2,2);
    VD = MID_STRING(RECEIVED_STRING,4,1);
    OBJECT = MID_STRING(RECEIVED_STRING,5,3);
    SV = MID_STRING(RECEIVED_STRING,8,2);
*)
    RECEIVED_STRING = MID_STRING(RECEIVED_STRING,2,LENGTH_STRING(RECEIVED_STRING));  //CHOP OFF EVENT
    
    MY_DATA = RIGHT_STRING(RECEIVED_STRING,4);
    
    FOR (I = 1;I<=T;I++)//T is assigned in startup by the order and number of 'subscribes' called
    {
	IF(LEFT_STRING(RECEIVED_STRING,8)== LEFT_STRING(FB[I],8))//HiQnet address and SV of each object; elements 9-12 are the values of the SV
	{//MATCH - POPULATE VALUES IN FB[] FOR TRUE FEEDBACK
	    FB[I][9] = MY_DATA[1];
	    FB[I][10] = MY_DATA[2];
	    FB[I][11] = MY_DATA[3];
	    FB[I][12] = MY_DATA[4];
	    
	    IF (EVENT = $8D)//SET%
	    {
		iGAIN_FRACTION =  TYPE_CAST(MID_STRING(FB[I],11,1))*256 + TYPE_CAST(MID_STRING(FB[I],12,1)) //TAKE THE FRACTIONAL PART OF THE GAIN FADER TO DECIDE WHETHER TO ROUND UP OR DOWN FOR CLOSEST INTEGER AND SEND TO TP
		IF (iGAIN_FRACTION > 32767)//ROUND UP TO NEXT INTEGER
		    FB[I][10] = FB[I][10]+1 
	    }

	    I=T //DUMP OUT OF THE LOOP 
	}
    }

(* 
//DEBUG
//SEND_STRING 0, "'SV ', ITOHEX(TYPE_CAST(SV[1]<<8)+SV[2]), 'DATA ',ITOHEX(TYPE_CAST(MY_DATA[1]<<32)+TYPE_CAST(MY_DATA[2]<<16)+TYPE_CAST(MY_DATA[3]<<8)+MY_DATA[4])"
    HEX_DATA = "";
    FOR(INDEX=1;INDEX<=LENGTH_STRING(RECEIVED_STRING);INDEX++)
    {
        HEX_DATA="HEX_DATA,FORMAT(' $%02X',RECEIVED_STRING[INDEX])"
	//HEX_DATA="HEX_DATA,FORMAT(' #%d',RECEIVED_STRING[INDEX])" //decimal
    }
    	SEND_STRING 0,"'STRING ',HEX_DATA"
*)

}



DEFINE_FUNCTION INTEGER GET_SV(INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //GET STATE VARIABLE
{
LOCAL_VAR INTEGER intSV;

SELECT 
 {
    ACTIVE ((DEVICE == AUTOMIXER)||(DEVICE == MIXER))://TO CONTROL INPUT CHANNEL PUT CHANNEL NUMBER IN 'INPUT' AND PUT 0 IN FOR OUTPUT;
    {		                                   // TO CONTROL OUTPUT PUT 0 IN INPUT AND L <1> OR R <3> IN OUTPUT
	IF(!(INPUT==0)&&(OUTPUT==0)) //OUTPUT FIELD = 0 SO MEANS ADJUST INPUT VALUES
	{
	    IF (PARAM == MUTE )
		intSV= 1+((INPUT-1)*100); 
	    ELSE IF (PARAM == GAIN)
		intSV = ((INPUT-1)*100); 
	    ELSE IF (PARAM == SOLO)
		intSV = (INPUT -1)*100 + 4;
	    ELSE IF (PARAM == OVERRIDE)
		intSV = (INPUT-1)*100+5;
	    ELSE IF (PARAM == AUTO)
		intSV = (INPUT-1)*100+7;
	    ELSE IF (PARAM == PAN)
		intSV = ((INPUT-1)*100+2);
	    ELSE IF (PARAM == OFF_GAIN)
		intSV = ((INPUT -1)*100+6);
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Mixer - PARAM TYPE NOT FOUND FOR NON-ZERO <INPUT> AND 0 <OUTPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
	ELSE IF((INPUT == 0) && (!(OUTPUT ==0))) //INPUT FIELD = 0 SO ADJUST OUTPUT VALUES (MASTER OUTPUTS)
	{
	    IF (PARAM == MUTE)
		intSV = 20000 + OUTPUT; //MUTE MASTER OUTPUT 20001 = LEFT; 20003 = RIGHT
	    ELSE IF(PARAM == GAIN)
		intSV = 20000 + OUTPUT - 1; //MUTE MASTER OUTPUT 20000 = LEFT; 20002 = RIGHT
	    ELSE IF(PARAM == AUX)
		intSV = (OUTPUT-1)*10 + 10002;
	    ELSE IF(PARAM == GROUP)
		intSV = (OUTPUT-1)*10+11001;
	    ELSE IF(PARAM == AUX_GAIN)
		intSV = ((OUTPUT-1)*10 + 10001);
	    ELSE IF(PARAM = GROUP_GAIN)
		intSV = ((OUTPUT-1)*10+11000);
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Mixer - PARAM TYPE NOT FOUND FOR NON-ZERO <OUTPUT> AND 0 <INPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
	ELSE IF(PARAM == GROUP)
		intSV = (INPUT-1)*100 + (OUTPUT-1)+40;//ROUTE TO GROUP
	ELSE //ERROR MESSAGE TO CONSOLE
	    SEND_STRING 0,"'BSS_ERROR: Set Mixer - PARAM TYPE NOT FOUND FOR 0 <INPUT> AND 0 <OUTPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	    
    }
    ACTIVE (DEVICE == ROOM_COMBINE)://TO CONTROL INPUT CHANNEL PUT CHANNEL NUMBER IN 'INPUT' AND PUT 0 IN FOR OUTPUT
    {
    	IF(!(INPUT==0)&&(OUTPUT==0)) //OUTPUT FIELD = 0 SO MEANS ADJUST INPUT VALUES
	{
	    IF (PARAM == SOURCE_MUTE)
		intSV = (INPUT-1)*50+256
	    ELSE IF (PARAM == BGM_MUTE)		
		intSV = (INPUT-1)*50+258
	    ELSE IF (PARAM == SOURCE_GAIN)		
		intSV = (INPUT-1)*50+255
	    ELSE IF (PARAM == BGM_GAIN)		
		intSV = (INPUT-1)*50+257
	    ELSE IF (PARAM == BGM_SELECT)//BACKGROUND MUSIC 		
		intSV = (INPUT-1)*50+259
	    ELSE IF (PARAM == PARTITION)
		intSV = (INPUT-1)
	    ELSE IF (PARAM == GROUP)
		intSV = (INPUT-1)*50 + 250
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Room Combine - PARAM TYPE NOT FOUND FOR NON-ZERO <INPUT> AND 0 <OUTPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
	ELSE IF((INPUT == 0) && (!(OUTPUT == 0))) //INPUT FIELD = 0 SO ADJUST OUTPUT VALUES (MASTER OUTPUTS)
	{
	    IF (PARAM == MASTER_MUTE)
		intSV = (OUTPUT -1)*50+254
	    ELSE IF (PARAM == MASTER_GAIN)		
		intSV = (OUTPUT -1)*50+252
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Room Combine - PARAM TYPE NOT FOUND FOR 0 <INPUT> AND NON-ZERO <OUTPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"    
	}
	ELSE //INPUT AND OUTPUT PARAMETERS ARE BOTH 0
	    SEND_STRING 0,"'BSS_ERROR: Message not supported for Room Combine. Either input or output MUST be = 0.  SEE HELP FILE.'"
	
    }
    ACTIVE ((DEVICE == ROUTER)||(DEVICE == MM)):
    {
	IF (PARAM == MUTE || PARAM == UNMUTE)
	    intSV = (INPUT-1)+((OUTPUT-1)*128); 
	ELSE IF (PARAM == GAIN)
	    intSV = (INPUT+16383)+((OUTPUT-1)*128);
	ELSE //ERROR MESSAGE TO CONSOLE
	    SEND_STRING 0,"'BSS_ERROR: Set Val - PARAM TYPE NOT FOUND FOR DEVICE = ROUTER || MIXER.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
    }
    ACTIVE (DEVICE == N_GAIN):
    {
	IF (OUTPUT == 0) //N_GAIN DEVICE; ADJUST INPUT
	{
	    IF (PARAM == MUTE || PARAM == UNMUTE)
		intSV = (INPUT-1)+32;
	    ELSE IF (PARAM == GAIN)
		intSV = INPUT-1;
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Val - PARAM TYPE NOT FOUND FOR DEVICE = N_GAIN <OUTPUT == 0>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
	ELSE IF (INPUT == 0) //N_GAIN DEVICE; ADJUST MASTER OUTPUT
	{
	    IF (PARAM == MUTE || PARAM == UNMUTE)
		intSV = 97;
	    ELSE IF (PARAM == GAIN)
		intSV = 96;    
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Val - PARAM TYPE NOT FOUND FOR DEVICE = N_GAIN <INPUT == 0>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
    }
    ACTIVE (DEVICE == GAIN):
    {
	IF ((OUTPUT == 0) && (INPUT == 1)) //SINGLE GAIN DEVICE
	{
	    IF (PARAM == MUTE || PARAM == UNMUTE)
		intSV = 1;
	    ELSE IF (PARAM == GAIN)
		intSV = 0;
	    ELSE IF (PARAM == POLARITY_ON || PARAM == POLARITY_OFF)
		intSV = 2;
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Val - PARAM TYPE NOT FOUND FOR DEVICE = GAIN <OUTPUT == 0>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
    }
    ACTIVE (DEVICE == SOURCE_SELECTOR):
    {
	intSV = 0;
    }
    ACTIVE (DEVICE == SOURCE_MATRIX):
    {
	intSV = (INPUT - 1);
    }
    ACTIVE (DEVICE == INPUT_CARD):
    {
	IF(PARAM == GAIN)
	{
	    IF(INPUT == 1)
		intSV = 4;
	    ELSE IF(INPUT == 2)
		intSV = 10;
	    ELSE IF(INPUT == 3)
		intSV = 16;
	    ELSE IF(INPUT == 4)
		intSV = 22;
	}
	ELSE IF(PARAM == METER)
	    intSV = (INPUT-1)*6;
	ELSE IF(PARAM == PHANTOM)
	    INTSV = (INPUT-1)*6+5;
	ELSE IF(PARAM == REFERENCE)
	    intSV = (INPUT-1)*6+1;
	ELSE IF(PARAM == ATTACK)
	    intSV = (INPUT-1)*6+2;
	ELSE IF(PARAM == RELEASED)
	    intSV = (INPUT-1)*6+3;
    }
    ACTIVE (DEVICE == OUTPUT_CARD):
    {
	IF(PARAM == METER)
	    intSV = (INPUT-1)* 4;
	ELSE IF(PARAM == REFERENCE)
	    intSV = (INPUT-1)*4+1;
	ELSE IF(PARAM == ATTACK)
	    intSV = (INPUT-1)*4+2;
	ELSE IF(PARAM == RELEASED)
	    intSV = (INPUT-1)*4+3;
    }
    ACTIVE (DEVICE == METER):
    {
	IF(PARAM == METER)
	    intSV = 0;
    }
 }

RETURN intSV;
}
DEFINE_FUNCTION INTEGER IS_SPECIAL(CHAR SPECIAL_CHAR) //CHECK FOR SPECIAL CHARACTERS
{
LOCAL_VAR INTEGER intSPECIAL;


    IF ((SPECIAL_CHAR < 2) || (SPECIAL_CHAR > 27))
	intSPECIAL = 0;
    ELSE
    {
	SELECT
	{
	    ACTIVE (SPECIAL_CHAR = $02): {intSPECIAL = 1;}
	    ACTIVE (SPECIAL_CHAR = $03): {intSPECIAL = 1;}
	    ACTIVE (SPECIAL_CHAR = $06): {intSPECIAL = 1;}
	    ACTIVE (SPECIAL_CHAR = $15): {intSPECIAL = 1;}
	    ACTIVE (SPECIAL_CHAR = $1B): {intSPECIAL = 1;}
	}
    }
    
RETURN intSPECIAL;
}

DEFINE_FUNCTION INTEGER HI_BYTE(INTEGER IBYTE)//RETURN INTEGER BITS 9-16 IN SINGLE CHAR
{
    LOCAL_VAR INTEGER intHBYTE;
    
    intHBYTE = TYPE_CAST(IBYTE >> 8); //HIGH BYTE
    
    RETURN intHBYTE;
}

DEFINE_FUNCTION INTEGER LO_BYTE(INTEGER IBYTE) //RETURN INTEGER BITS 1-8 IN SINGLE CHAR
{
    LOCAL_VAR INTEGER intLBYTE;
    
    intLBYTE = TYPE_CAST(IBYTE << 8);
    intLBYTE = TYPE_CAST(intLBYTE >> 8); //LOW BYTE
    
    RETURN intLBYTE;
}

DEFINE_FUNCTION INTEGER scaleRange(LONG Num_In, LONG Min_In, LONG Max_In, LONG Min_Out, LONG Max_Out)
{
 
    LOCAL_VAR LONG Val_In
    LOCAL_VAR LONG Range_In
    LOCAL_VAR LONG Range_Out
    LOCAL_VAR LONG Whole_Num
    LOCAL_VAR FLOAT Num_Out

    
    Val_In = (Num_In/65536)         //Convert received number to percent range
    IF(Val_In == Min_In)            // Handle endpoints
        {Num_Out = Min_Out}
    ELSE IF(Val_In == Max_In)
        {Num_Out = Max_Out}
    ELSE                            // Otherwise scale...
    {
        Range_In = Max_In - Min_In      // Establish input range
        Range_Out = Max_Out - Min_Out   // Establish output range
        Val_In = Val_In - Min_In        // Remove input offset
        Num_Out = Val_In * Range_Out    // Multiply by output range
        Num_Out = Num_Out / Range_In    // Then divide by input range
        Num_Out = Num_Out + Min_Out     // Add in minimum output value
        Whole_Num = TYPE_CAST(Num_Out)  // Store the whole number only of the result
        IF (Num_Out >= 0 AND (((Num_Out - Whole_Num)* 100.0) >= 50.0)) 
	{
	    Num_Out++ // round up
	}    
        ELSE IF (Num_Out < 0 AND (((Num_Out - Whole_Num) * 100.0) <= -50.0))
	{ 
	    Num_Out-- // round down
	}    
    }
    Return TYPE_CAST(Num_Out)
}

DEFINE_FUNCTION LONG CHAR_LONGVAL(CHAR VALUE[4]) //TAKES A CHAR[4] ARRAY AND RETURNS A LONG
{
LOCAL_VAR INTEGER NUM1;   
LOCAL_VAR INTEGER NUM2; 
LOCAL_VAR INTEGER NUM3; 
LOCAL_VAR INTEGER NUM4; 
LOCAL_VAR LONG L_INT;

    NUM1 = VALUE[1];
    NUM2 = VALUE[2];
    NUM3 = VALUE[3];
    NUM4 = VALUE[4];

    L_INT = (NUM1*2^24)+(NUM2*65536)+(NUM3*256)+NUM4;
    
RETURN L_INT;
}
DEFINE_FUNCTION fnLOG_HEX(CHAR cDATA[], INTEGER LENGTH, CHAR cMESSAGE[]) // USED FOR HEX LOGGING TO TELNET
{
    STACK_VAR INTEGER INDEX
    STACK_VAR CHAR HEX_DATA[5000] // MAX SIZE  
    FOR(INDEX=1;INDEX<=LENGTH;INDEX++)
        HEX_DATA="HEX_DATA,FORMAT(' $%02X',cDATA[INDEX])"
    WHILE(LENGTH_STRING(HEX_DATA))
      {
        SEND_STRING 0,"cMESSAGE,GET_BUFFER_STRING(HEX_DATA,80)"
      }
    
}

DEFINE_FUNCTION fnLOG_DEC(CHAR cDATA[], INTEGER LENGTH, CHAR cMESSAGE[]) // USED FOR DECIMAL LOGGING
{
    STACK_VAR INTEGER INDEX
    STACK_VAR CHAR DEC_DATA[300]
    IF(LENGTH>100)
       LENGTH=100
    FOR(INDEX=1;INDEX<=LENGTH;INDEX++)
        DEC_DATA="DEC_DATA,FORMAT(' #%d',cDATA[INDEX])"
    SEND_STRING 0,"cMESSAGE,DEC_DATA"
    SET_LENGTH_STRING(DEC_DATA,0)
}
DEFINE_FUNCTION INTEGER fnParseRx(CHAR cBUFFER[])
{
    LOCAL_VAR INTEGER J; //RECEIVE LOOP VAR
    LOCAL_VAR INTEGER GOT_ESCAPE; 
    LOCAL_VAR CHAR R_SP; //RECEIVE SPECIAL CHARACTER
    LOCAL_VAR CHAR R_CS; //RECEIVE CHECKSUM
    LOCAL_VAR CHAR RECEIVE[25]; //TOTAL REAL RECEIVED MESSAGE AFTER CONVERTING SPECIAL CHARS
    LOCAL_VAR CHAR TEMP[25]; //PARSING TEMP VAR
    LOCAL_VAR CHAR T_CS; //TRANSMITTED CHECKSUM

	IF (LEFT_STRING(cBUFFER,1) = "ACK")//CHECK FOR ACK
	{
	    GET_BUFFER_CHAR(cBUFFER)//REMOVE FROM BUFFER
	    //IF(bDEBUG_FLAG==2) SEND_STRING 0,"' ACK'"
	    RETURN TRUE
	    //DO STUFF HERE FOR CORRECTLY TRANSMITTED STRING
	}
	ELSE IF (LEFT_STRING(cBUFFER,1) = "NAK")//CHECK FOR NAK
	{
	    GET_BUFFER_CHAR(cBUFFER)//REMOVE FROM BUFFER
	    IF(bDEBUG_FLAG==2) SEND_STRING 0,"' NAK'"
	    RETURN TRUE
	    //DO STUFF HERE FOR INCORRECT TRANSMITTED STRING
	}
	ELSE IF((cBUFFER[1] == "STX") && (FIND_STRING(cBUFFER,"ETX",1))) //FULL MESSAGE
	{
	    //SEND_STRING 0, "'FULL MESSAGE RECEIVED '"
	    nAttempts = 0
	    TEMP = REMOVE_STRING(cBUFFER,"ETX",1)//REMOVE STRING TO ETX
	    TEMP = MID_STRING(TEMP,2,(LENGTH_STRING(TEMP)-2));//CHOP OFF STX/ETX
	    RECEIVE = "";//INITIALIZE
	    R_CS = 0;//INITIALIZE
			
	    IF((MID_STRING(TEMP,(LENGTH_STRING(TEMP)-1),1)) = $1B) //CS IS SPECIAL CHAR
	    {
		T_CS = (TYPE_CAST(RIGHT_STRING(TEMP,1))-128)
		TEMP = MID_STRING(TEMP,1,(LENGTH_STRING(TEMP)-2))
	    }
	    ELSE
	    {
		T_CS = TYPE_CAST(RIGHT_STRING(TEMP,1))
		TEMP = MID_STRING(TEMP,1,(LENGTH_STRING(TEMP)-1))//THE (-1) IS TO REMOVE THE CHECKSUM FROM CALCULATIONS
	    }
	    FOR (J = 1;J <= LENGTH_STRING(TEMP);J++) //REPLACE SPECIAL CHARS AND GENERATE CHECKSUM
	    {                               
		IF (TEMP[J] = "$1B") //ESCAPE CHAR
		    GOT_ESCAPE = 1;
		ELSE
		{
		    IF (GOT_ESCAPE)
		    {
			R_SP = (TEMP[J]-128);
			R_CS = R_CS BXOR R_SP;
			RECEIVE = "RECEIVE,R_SP";
			GOT_ESCAPE = 0;
		    }
		    ELSE
		    {
			R_CS = R_CS BXOR TEMP[J];
			RECEIVE = "RECEIVE,TEMP[J]";
		    }
		}
	    }
	    IF (R_CS == T_CS)//MAKE SURE CHECKSUM = RECEIVED CHECKSUM AND MESSAGE IS RIGHT SIZE
		CALL 'PROCESS_FEEDBACK'(RECEIVE)
	    ELSE IF (bDEBUG_FLAG==2)
		SEND_STRING 0,"'BSS MESSAGE: BAD CHECKSUM OR MESSAGE LENGTH'"

	    RETURN TRUE
	}//FULL MESSAGE
	ELSE IF(cBUFFER[1]=="STX") // If we have received STX but the message is too short to be validated
	{
	    nAttempts++
	    IF(nAttempts>=5) 
	    {
		nAttempts = 0
		cBUFFER='' // clear the buffer after 5 failed attemps to receive a full message
		SEND_STRING 0, "'BSS MESSAGE: "ONLY STX RECEIVED: Partial Message" DUMPED '"
	    }
	    RETURN FALSE
	}
	ELSE // unrecognized reply...
	{
	    nAttempts = 0
	    cBUFFER = ''
	    RETURN FALSE
	    SEND_STRING 0, "'BSS MESSAGE: "UNRECOGNIZED REPLY" DUMPED '"
	}
}



(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

CREATE_BUFFER dvSOUNDWEB,cBUFFER
CLEAR_BUFFER cBUFFER
//bDEBUG_FLAG = 2


 SMAT_OUT = 1;
 MMIX_OUT = 1;

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT [dvSOUNDWEB]
{
    ONLINE:
    {	
	STACK_VAR INTEGER I;//LOOP VAR
	STACK_VAR INTEGER J;//LOOP VAR
	T = 0; //initialize

	SEND_COMMAND dvSOUNDWEB, 'SET BAUD 115200,N,8,1 485 DISABLE'

	STARTUP = 1; //BEGIN LOGGING FEEDBACK VARIABLES:  THESE ARE THE ONLY VARIABLES 
		 //THAT WILL BE COMPARED TO RECEIVED STRINGS FOR TRUE FEEDBACK
	    
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,1,0,MUTE) //FB[1] -- THIS IS THE VALUE YOU USE IN DEFINE_PROGRAM FOR FEEDBACK
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,2,0,MUTE) //FB[2]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,3,0,MUTE) //FB[3]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,4,0,MUTE) //FB[4]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,1,MUTE) //FB[5]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,3,MUTE) //FB[6]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,1,GROUP) //FB[7]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,2,GROUP) //FB[8]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,3,GROUP) //FB[9]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,4,GROUP) //FB[10]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,1,AUX) //FB[11]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,2,AUX) //FB[12]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,3,AUX) //FB[13]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,4,AUX) //FB[14]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,1,0,SOLO) //FB[15]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,2,0,SOLO)//FB[16]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,3,0,SOLO)//FB[17]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,4,0,SOLO)//FB[18]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,1,0,AUTO)//FB[19]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,2,0,AUTO)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,3,0,AUTO)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,4,0,AUTO)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,1,0,OVERRIDE)//FB[23]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,2,0,OVERRIDE)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,3,0,OVERRIDE)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,4,0,OVERRIDE)
	    
	T = 29 
	FOR(I=1;I<=8;I++)//FB[30] -> FB[93] MATRIX_MIXER
	{
	    FOR(J=1;J<=8;J++)
	    {
		CALL 'SUBSCRIBE'(MICS,MM,J,I,ROUTE)
	    }
	}
	    
	FOR(I=1;I<=4;I++) //FB[94-109] MATRIX ROUTER
	{
	    FOR(J=1;J<=4;J++)
	    {
		CALL 'SUBSCRIBE'(VIDEO_SERVER,ROUTER,J,I,ROUTE) 
	    }
	}
	    
	FOR(I=1;I<=4;I++) //FB[110-125] AUTOMIXER GROUP INPUTS
	{
	    FOR(J=1;J<=4;J++)
	    {
		CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,I,J,GROUP) 
	    }
	}
	    
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,1,0,GAIN)//FB[126]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,2,0,GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,3,0,GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,4,0,GAIN)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,1,0,MUTE)//FB[130] 
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,2,0,MUTE)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,3,0,MUTE)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,4,0,MUTE)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,1,0,SOLO)//FB[134]
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,2,0,SOLO)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,3,0,SOLO)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,4,0,SOLO)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,0,1,MUTE)//FB[138]
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,1,0,PHANTOM)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,2,0,PHANTOM)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,3,0,PHANTOM)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,4,0,PHANTOM)//FB[142]
	CALL 'SUBSCRIBE'(WC_GAIN,GAIN,1,0,MUTE)
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,1,0,MUTE)//FB[144]
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,2,0,MUTE)
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,3,0,MUTE)
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,4,0,MUTE)
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,0,1,MUTE)
	CALL 'SUBSCRIBE'(BRIEFING_ROOM,SOURCE_SELECTOR,0,0,0)//FB[149]
	
	FOR(J=1;J<=8;J++)//FB[150-157]
	{
	    CALL 'SUBSCRIBE'(SYSTEM_MATRIX,SOURCE_MATRIX,J,0,ROUTE)
	}
	
	CALL 'UN_SUBSCRIBE%'(IO_CARD1,OUTPUT_CARD,1,0,METER) //FB[158]--[161] ARE PLACE HOLDERS IN FB ARRAY.
	CALL 'UN_SUBSCRIBE%'(IO_CARD1,OUTPUT_CARD,2,0,METER) //FB[159]   	SUBSCRIBES ARE CALLED IN BUTTON_EVENT 10
	CALL 'UN_SUBSCRIBE%'(IO_CARD1,OUTPUT_CARD,3,0,METER) //FB[160]
	CALL 'UN_SUBSCRIBE%'(IO_CARD1,OUTPUT_CARD,4,0,METER) //FB[161]
	CALL 'SUBSCRIBE%'(WC_GAIN,GAIN,1,0,GAIN)
	
	//SUBSCRIBING TO METERS CAUSES A LOT OF SERIAL TRAFFIC, USE WITH CARE
	//CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,1,0,METER) //FB[21]

	STARTUP = 0; //END LOGGING FEEDBACK VARIABLES
    }//ONLINE
    STRING:
    {
	//IF(bDEBUG_FLAG==2) // if full debug ON, print everything...
	    //fnLog_Hex(cBUFFER,LENGTH_STRING(cBUFFER),'received  <-- ')
	WHILE(fnParseRx(cBUFFER)) {/*DO NOTHING*/}
    }//STRING:

}//DATA_EVENT
LEVEL_EVENT[dvTP,1]//MATRIX MIXER
{
    CALL 'SET_GAIN%'(MICS,MM,1,MMIX_OUT,LEVEL.VALUE)
}
LEVEL_EVENT[dvTP,2]//AUTOMIXER GAINS
LEVEL_EVENT[dvTP,3]
LEVEL_EVENT[dvTP,4]
LEVEL_EVENT[dvTP,5]
LEVEL_EVENT[dvTP,7]
LEVEL_EVENT[dvTP,8]
LEVEL_EVENT[dvTP,9]
LEVEL_EVENT[dvTP,10]
LEVEL_EVENT[dvTP,11]
LEVEL_EVENT[dvTP,12]
LEVEL_EVENT[dvTP,13]
LEVEL_EVENT[dvTP,14]
LEVEL_EVENT[dvTP,15]
LEVEL_EVENT[dvTP,16]
LEVEL_EVENT[dvTP,17]
LEVEL_EVENT[dvTP,18]
LEVEL_EVENT[dvTP,19]
LEVEL_EVENT[dvTP,20]
LEVEL_EVENT[dvTP,21]
LEVEL_EVENT[dvTP,22]
LEVEL_EVENT[dvTP,23]
LEVEL_EVENT[dvTP,24]
{
    IF(LEVEL.INPUT.LEVEL <=5)
	CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,(LEVEL.INPUT.LEVEL-1),0,LEVEL.VALUE)//INPUTS
    ELSE IF(LEVEL.INPUT.LEVEL=7)
	CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,0,(LEVEL.INPUT.LEVEL-6),LEVEL.VALUE)//LEFT
    ELSE IF(LEVEL.INPUT.LEVEL=8)
	CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,0,(LEVEL.INPUT.LEVEL-5),LEVEL.VALUE)//RIGHT
    ELSE IF((LEVEL.INPUT.LEVEL >=9)&&(LEVEL.INPUT.LEVEL <=12))
	CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-8),0,PAN,LEVEL.VALUE)//PAN
    ELSE IF((LEVEL.INPUT.LEVEL >=13)&&(LEVEL.INPUT.LEVEL <=16))	
	CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-12),0,OFF_GAIN,LEVEL.VALUE)//OFF_GAIN
    ELSE IF((LEVEL.INPUT.LEVEL >=17)&&(LEVEL.INPUT.LEVEL <=20))	
	CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-16),AUX_GAIN,LEVEL.VALUE)//AUX_GAIN
    ELSE IF((LEVEL.INPUT.LEVEL >=21)&&(LEVEL.INPUT.LEVEL <=24))	
	CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-20),GROUP_GAIN,LEVEL.VALUE)//GROUP_GAIN
}

LEVEL_EVENT[dvTP,25]//MIXER GAINS
LEVEL_EVENT[dvTP,26]
LEVEL_EVENT[dvTP,27]
LEVEL_EVENT[dvTP,28]
LEVEL_EVENT[dvTP,29]
{
    IF(LEVEL.INPUT.LEVEL <=28)
	CALL 'SET_GAIN%'(MR_MIC_MIXER,MIXER,(LEVEL.INPUT.LEVEL-24),0,LEVEL.VALUE)//INPUTS
    ELSE IF(LEVEL.INPUT.LEVEL=29)
	CALL 'SET_GAIN%'(MR_MIC_MIXER,MIXER,0,(LEVEL.INPUT.LEVEL-28),LEVEL.VALUE)//LEFT OUT

}

LEVEL_EVENT[dvTP,30]//INPUT_CARD
LEVEL_EVENT[dvTP,31]
LEVEL_EVENT[dvTP,32]
LEVEL_EVENT[dvTP,33]
LEVEL_EVENT[dvTP,34]
LEVEL_EVENT[dvTP,35]
LEVEL_EVENT[dvTP,36]
LEVEL_EVENT[dvTP,37]
LEVEL_EVENT[dvTP,38]
LEVEL_EVENT[dvTP,39]
LEVEL_EVENT[dvTP,40]
LEVEL_EVENT[dvTP,41]
{
    IF(LEVEL.INPUT.LEVEL <=33)
	CALL 'SET_GAIN%'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-29),0,LEVEL.VALUE)//GAIN
    ELSE IF((LEVEL.INPUT.LEVEL >=34)&&(LEVEL.INPUT.LEVEL <=37))	
	CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-33),0,ATTACK,LEVEL.VALUE)//ATTACK
    ELSE IF((LEVEL.INPUT.LEVEL >=38)&&(LEVEL.INPUT.LEVEL <=41))	
	CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-37),0,RELEASED,LEVEL.VALUE)//RELEASED
}
(*
LEVEL_EVENT[dvTP,42] //GAIN FB[162] 
{
LOCAL_VAR FLOAT VOL;
LOCAL_VAR INTEGER PERCENT; 
LOCAL_VAR INTEGER MODI;
LOCAL_VAR CHAR MY_LEVEL;
    

    IF (FB[162][10] <> LEVEL.VALUE)
    {
	FB[162][10] = LEVEL.VALUE; //FB[162] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,1,0,LEVEL.VALUE)
	//SEND_COMMAND dvTP, "'TEXT1 -',ITOA(PERCENT),'%'"; //SEND TEXT TO TP
    }

}
*)
LEVEL_EVENT[dvTP,43]//NGAIN
LEVEL_EVENT[dvTP,44]
LEVEL_EVENT[dvTP,45]
LEVEL_EVENT[dvTP,46]
LEVEL_EVENT[dvTP,47]
{
    IF(LEVEL.INPUT.LEVEL<=46)
	CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,(LEVEL.INPUT.LEVEL-42),0,LEVEL.VALUE)//INPUTS
    ELSE
	CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,0,(LEVEL.INPUT.LEVEL-46),LEVEL.VALUE)//OUT
}
LEVEL_EVENT[dvTP,48]//OUTPUT_CARD
LEVEL_EVENT[dvTP,49]
LEVEL_EVENT[dvTP,50]
LEVEL_EVENT[dvTP,51]
LEVEL_EVENT[dvTP,52]
LEVEL_EVENT[dvTP,53]
LEVEL_EVENT[dvTP,54]
LEVEL_EVENT[dvTP,55]
LEVEL_EVENT[dvTP,56]
LEVEL_EVENT[dvTP,57]
LEVEL_EVENT[dvTP,58]
LEVEL_EVENT[dvTP,59]
{
    IF(LEVEL.INPUT.LEVEL <=51)
	CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-47),0,ATTACK,LEVEL.VALUE)//ATTACK
    ELSE IF((LEVEL.INPUT.LEVEL >=52)&&(LEVEL.INPUT.LEVEL <=55))	
	CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-51),0,RELEASED,LEVEL.VALUE)//RELEASE
    ELSE IF((LEVEL.INPUT.LEVEL >=56)&&(LEVEL.INPUT.LEVEL <=59))	
	CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-55),0,REFERENCE,LEVEL.VALUE)//REFERENCE

}



(****************************************  BUTTON_EVENTS ******************************************************************************************)
BUTTON_EVENT [dvTP,1] //MENU BUTTONS
BUTTON_EVENT [dvTP,2]
BUTTON_EVENT [dvTP,3]
BUTTON_EVENT [dvTP,4]
BUTTON_EVENT [dvTP,5]
BUTTON_EVENT [dvTP,6]
BUTTON_EVENT [dvTP,7]
BUTTON_EVENT [dvTP,8]
BUTTON_EVENT [dvTP,9]
{
PUSH: 
    {
(*    
    IF(menuOUTPUTCARD)
	{
	CALL 'UN_SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,METER) 
	CALL 'UN_SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,2,0,METER) 
	//CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,METER) 
	//CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,METER) 
	menuOUTPUTCARD =0
	}
*)
    }

}

BUTTON_EVENT [dvTP,10]//MENU OUTPUT_CARD BUTTON
{
PUSH: 
    {
(*
    CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,METER) //FB[21]
    CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,2,0,METER) //FB[22]
    //CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,3,0,METER) //FB[23]
    //CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,4,0,METER) //FB[24]
    menuOUTPUTCARD =1
*)
    }
}
BUTTON_EVENT [dvTP,15]//MATRIX MIXER SOURCE
BUTTON_EVENT [dvTP,16]
BUTTON_EVENT [dvTP,17]
BUTTON_EVENT [dvTP,18]
BUTTON_EVENT [dvTP,19]
BUTTON_EVENT [dvTP,20]
BUTTON_EVENT [dvTP,21]
BUTTON_EVENT [dvTP,22]
{
PUSH: 
    {
    LOCAL_VAR INTEGER FB_INDEX;
    
    FB_INDEX =((MMIX_OUT-1)*8)+((PUSH_CHANNEL-14)+29)
    IF(FB[FB_INDEX][12])//UNROUTE
	{
	CALL 'SET_VAL'(MICS,MM,(PUSH_CHANNEL-14),MMIX_OUT,MUTE,0)
	}
    ELSE //ROUTE
	{
	CALL 'SET_VAL'(MICS,MM,(PUSH_CHANNEL-14),MMIX_OUT,MUTE,1)
	}

    }
}

BUTTON_EVENT [dvTP,23]//MATRIX MIXER DESTINATION
BUTTON_EVENT [dvTP,24]
BUTTON_EVENT [dvTP,25]
BUTTON_EVENT [dvTP,26]
BUTTON_EVENT [dvTP,27]
BUTTON_EVENT [dvTP,28]
BUTTON_EVENT [dvTP,29]
BUTTON_EVENT [dvTP,30]
{
PUSH: 
    {
    MMIX_OUT = (PUSH_CHANNEL-22)
    ON[dvTP,PUSH_CHANNEL]
    SEND_LEVEL DVTP,1,MMIX_VOL[MMIX_OUT];
    }
}


BUTTON_EVENT [dvTP,31]//MATRIX ROUTER
BUTTON_EVENT [dvTP,32]
BUTTON_EVENT [dvTP,33]
BUTTON_EVENT [dvTP,34]
BUTTON_EVENT [dvTP,35]
BUTTON_EVENT [dvTP,36]
BUTTON_EVENT [dvTP,37]
BUTTON_EVENT [dvTP,38]
BUTTON_EVENT [dvTP,39]
BUTTON_EVENT [dvTP,40]
BUTTON_EVENT [dvTP,41]
BUTTON_EVENT [dvTP,42]
BUTTON_EVENT [dvTP,43]
BUTTON_EVENT [dvTP,44]
BUTTON_EVENT [dvTP,45]
BUTTON_EVENT [dvTP,46]
{
PUSH:
    {
    IF((PUSH_CHANNEL-30)<=4)
	{
	IF(FB[(PUSH_CHANNEL+63)][12])
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-30),1,ROUTE,0)
	ELSE
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-30),1,ROUTE,1)
	}
    ELSE IF((PUSH_CHANNEL-30 >=5) && (PUSH_CHANNEL-30 <= 8))
	{
	IF(FB[(PUSH_CHANNEL+63)][12])
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-34),2,ROUTE,0)
	ELSE
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-34),2,ROUTE,1)
	}
    ELSE IF((PUSH_CHANNEL-30>= 9) && (PUSH_CHANNEL -30 <= 12))
	{
	IF(FB[PUSH_CHANNEL+63][12])
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-38),3,ROUTE,0)
	ELSE
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-38),3,ROUTE,1)
	}
    ELSE IF((PUSH_CHANNEL-30 >= 13) && (PUSH_CHANNEL-30 <=16))
	{
	IF(FB[PUSH_CHANNEL+63][12])
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-42),4,ROUTE,0)
	ELSE
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-42),4,ROUTE,1)
	}
    }
}

(************************************** AUTOMIXER  *************************************************)
	
BUTTON_EVENT [dvTP,50]//AUTOMIXER INPUT MUTES
BUTTON_EVENT [dvTP,51]
BUTTON_EVENT [dvTP,52]
BUTTON_EVENT [dvTP,53]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-49][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-49,0,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-49,0,MUTE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,54]//SOLO
BUTTON_EVENT [dvTP,55]
BUTTON_EVENT [dvTP,56]
BUTTON_EVENT [dvTP,57]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-39][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-53,0,SOLO,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-53,0,SOLO,1) 
	}
    }
}
BUTTON_EVENT [dvTP,62]//AUTO
BUTTON_EVENT [dvTP,63]
BUTTON_EVENT [dvTP,64]
BUTTON_EVENT [dvTP,65]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-43][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-61,0,AUTO,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-61,0,AUTO,1) 
	}
    }
}
BUTTON_EVENT [dvTP,66]//OVERRIDE
BUTTON_EVENT [dvTP,67]
BUTTON_EVENT [dvTP,68]
BUTTON_EVENT [dvTP,69]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-43][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-65,0,OVERRIDE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-65,0,OVERRIDE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,70]//GROUP INPUT 1
BUTTON_EVENT [dvTP,71]
BUTTON_EVENT [dvTP,72]
BUTTON_EVENT [dvTP,73]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+40][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,1,PUSH_CHANNEL-69,GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,1,PUSH_CHANNEL-69,GROUP,1) 
	}
    }
}
BUTTON_EVENT [dvTP,74]//GROUP INPUT 2
BUTTON_EVENT [dvTP,75]
BUTTON_EVENT [dvTP,76]
BUTTON_EVENT [dvTP,77]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+40][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,2,PUSH_CHANNEL-73,GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,2,PUSH_CHANNEL-73,GROUP,1) 
	}
    }
}
BUTTON_EVENT [dvTP,78]//GROUP INPUT 3
BUTTON_EVENT [dvTP,79]
BUTTON_EVENT [dvTP,80]
BUTTON_EVENT [dvTP,81]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+40][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,3,PUSH_CHANNEL-77,GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,3,PUSH_CHANNEL-77,GROUP,1) 
	}
    }
}
BUTTON_EVENT [dvTP,82]//GROUP INPUT 4
BUTTON_EVENT [dvTP,83]
BUTTON_EVENT [dvTP,84]
BUTTON_EVENT [dvTP,85]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+40][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,4,PUSH_CHANNEL-81,GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,4,PUSH_CHANNEL-81,GROUP,1) 
	}
    }
}
BUTTON_EVENT[dvTP,86]
{
PUSH:
    {
    IF(FB[5][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,1,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,1,MUTE,1) 
	}
    }
}
BUTTON_EVENT[dvTP,87]
{
PUSH:
    {
    IF(FB[6][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,3,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,3,MUTE,1) 
	}
    }
}
BUTTON_EVENT[dvTP,88] //MASTER GROUP OUTPUTE MUTES
BUTTON_EVENT[dvTP,89]
BUTTON_EVENT[dvTP,90]
BUTTON_EVENT[dvTP,91]
{
PUSH:
    {
    IF(FB[PUSH_CHANNEL-81][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,(PUSH_CHANNEL-87),GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,(PUSH_CHANNEL-87),GROUP,1) 
	}
    }
}
BUTTON_EVENT[dvTP,92] //MASTER AUX OUTPUT MUTES
BUTTON_EVENT[dvTP,93]
BUTTON_EVENT[dvTP,94]
BUTTON_EVENT[dvTP,95]
{
PUSH:
    {
    IF(FB[PUSH_CHANNEL-81][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,(PUSH_CHANNEL-91),AUX,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,(PUSH_CHANNEL-91),AUX,1) 
	}
    }
}

(*****************************************  MIXER    *************************************************)
BUTTON_EVENT [dvTP,100]//MIXER INPUT MUTES
BUTTON_EVENT [dvTP,101]
BUTTON_EVENT [dvTP,102]
BUTTON_EVENT [dvTP,103]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+30][12])
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,PUSH_CHANNEL-99,0,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,PUSH_CHANNEL-99,0,MUTE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,104]//MIXER SOLO
BUTTON_EVENT [dvTP,105]
BUTTON_EVENT [dvTP,106]
BUTTON_EVENT [dvTP,107]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+30][12])
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,PUSH_CHANNEL-103,0,SOLO,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,PUSH_CHANNEL-103,0,SOLO,1) 
	}
    }
}
BUTTON_EVENT [dvTP,108]//MIXER OUT MUTE
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+30][12])
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,0,1,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,0,1,MUTE,1) 
	}
    }
}

BUTTON_EVENT [dvTP,110]//INPUT_CARD PHANTOM
BUTTON_EVENT [dvTP,111]
BUTTON_EVENT [dvTP,112]
BUTTON_EVENT [dvTP,113]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+29][12])
	{
	CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,PUSH_CHANNEL-109,0,PHANTOM,0) 
	}
    ELSE
	{
	CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,PUSH_CHANNEL-109,0,PHANTOM,100) 
	}
    }
}


BUTTON_EVENT [dvTP,115]//GAIN - MUTE
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+28][12])
	{
	CALL 'SET_VAL'(WC_GAIN,GAIN,PUSH_CHANNEL-114,0,MUTE,0)
	}
    ELSE
	{
	CALL 'SET_VAL'(WC_GAIN,GAIN,PUSH_CHANNEL-114,0,MUTE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,116]//nGAIN - MUTE
BUTTON_EVENT [dvTP,117]
BUTTON_EVENT [dvTP,118]
BUTTON_EVENT [dvTP,119]
BUTTON_EVENT [dvTP,120]
{
PUSH:
    {
    IF(PUSH_CHANNEL<=119) //THIS ALLOWS PUSH_CHANNEL TO BE INTEGER 1-4 WHICH MATCHES NUMBER OF NGAIN INPUTS
    {
	IF(FB[PUSH_CHANNEL+28][12]) //USING PUSH_CHANNEL TO GET TO PROPER FB[]
	{
	    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,PUSH_CHANNEL-115,0,MUTE,0)
	}
	ELSE
	{
	    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,PUSH_CHANNEL-115,0,MUTE,1) 
	}
    }
    ELSE
	IF(FB[PUSH_CHANNEL+28][12])
	{
	    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,0,PUSH_CHANNEL-119,MUTE,0)
	}
	ELSE
	{
	    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,0,PUSH_CHANNEL-119,MUTE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,125]//SOURCE_SELECTOR
BUTTON_EVENT [dvTP,126]
BUTTON_EVENT [dvTP,127]
BUTTON_EVENT [dvTP,128]
BUTTON_EVENT [dvTP,129]
BUTTON_EVENT [dvTP,130]
BUTTON_EVENT [dvTP,131]
BUTTON_EVENT [dvTP,132]
BUTTON_EVENT [dvTP,133]
{
PUSH:
    {
    CALL 'SET_VAL'(BRIEFING_ROOM,SOURCE_SELECTOR,1,0,ROUTE,PUSH_CHANNEL-125)
    }
}

BUTTON_EVENT [dvTP,135]//SOURCE_MATRIX INPUTS
BUTTON_EVENT [dvTP,136]
BUTTON_EVENT [dvTP,137]
BUTTON_EVENT [dvTP,138]
BUTTON_EVENT [dvTP,139]
BUTTON_EVENT [dvTP,140]
BUTTON_EVENT [dvTP,141]
BUTTON_EVENT [dvTP,142]
{
PUSH:
    {
    CALL 'SET_VAL'(SYSTEM_MATRIX,SOURCE_MATRIX,SMAT_OUT,0,ROUTE,(PUSH_CHANNEL-134))
    }
}
BUTTON_EVENT [dvTP,143]//SOURCE_MATRIX
BUTTON_EVENT [dvTP,144]
BUTTON_EVENT [dvTP,145]
BUTTON_EVENT [dvTP,146]
BUTTON_EVENT [dvTP,147]
BUTTON_EVENT [dvTP,148]
BUTTON_EVENT [dvTP,149]
BUTTON_EVENT [dvTP,150]
{
PUSH:
    {
    SMAT_OUT = (PUSH_CHANNEL-142)
    ON[dvTP,PUSH_CHANNEL]
    }
}



(* SAMPLE OF CONTROLLING MASTER GAIN FADER ON A MIXER USE A NON-ACTIVE BARGRAPH.  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN INPUT SPECIFIES YOU WANT TO CONTROL OUTPUT FADER
BUTTON_EVENT [dvTP,151]
{
PUSH: //RAMP UP
    {
    //CALL 'SET_VAL'(DANCE_MIXER,MIXER,0,L,UNMUTE) //OUTPUT LEFT UNMUTE (if mono then master out mute)
    
    IF (MasterOut_Vol < (MAX_RAMPGAIN_PER-GAIN_STEP_PER))
	{
	MasterOut_Vol = MasterOut_Vol + GAIN_STEP_PER;
	FB[162][10] = TYPE_CAST(MASTEROUT_VOL);
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,1,0,MASTEROUT_VOL)
	
	}
    }
HOLD[1,REPEAT]:
    {
    IF (MasterOut_Vol < (MAX_RAMPGAIN_PER-GAIN_STEP_PER))
	{
	MasterOut_Vol = MasterOut_Vol + GAIN_STEP_PER;
	FB[162][10] = TYPE_CAST(MASTEROUT_VOL);
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,1,0,masterout_vol)
	
	}
    }

}

(* SAMPLE OF CONTROLLING MASTER GAIN FADER ON A MIXER.  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN INPUT SPECIFIES YOU WANT TO CONTROL OUTPUT FADER
BUTTON_EVENT [dvTP,152]
{
PUSH://RAMP DOWN
    {
    //CALL 'SET_VAL'(DANCE_MIXER,MIXER,0,L,UNMUTE) //OUTPUT LEFT UNMUTE (if mono then master out mute)
    
    IF (MasterOut_Vol > (MIN_RAMPGAIN_PER+GAIN_STEP_PER))
	{
	MasterOut_Vol = MasterOut_Vol - GAIN_STEP_PER;
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,0,1,MasterOut_Vol)
	FB[162][10] = TYPE_CAST(MASTEROUT_VOL);
	}
    }
HOLD[1,REPEAT]:
    {
    IF (MasterOut_Vol > (MIN_RAMPGAIN_PER+GAIN_STEP_PER))
	{
	MasterOut_Vol = MasterOut_Vol - GAIN_STEP_PER;
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,0,1,MasterOut_Vol)
	FB[162][10] = TYPE_CAST(MASTEROUT_VOL);
	}
    }

}




(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM


(********************************** INFOCOMM**********************)
(*********** MATRIX MIXER ***********************)
MMIX_FB = ((MMIX_OUT-1)*8);
[dvTP,15] = FB[MMIX_FB+30][12];
[dvTP,16] = FB[MMIX_FB+31][12];
[dvTP,17] = FB[MMIX_FB+32][12];
[dvTP,18] = FB[MMIX_FB+33][12];
[dvTP,19] = FB[MMIX_FB+34][12];
[dvTP,20] = FB[MMIX_FB+35][12];
[dvTP,21] = FB[MMIX_FB+36][12];
[dvTP,22] = FB[MMIX_FB+37][12];

(******** MATRIX ROUTER *********************)
[dvTP,31] = FB[94][12];
[dvTP,32] = FB[95][12];
[dvTP,33] = FB[96][12]
[dvTP,34] = FB[97][12];
[dvTP,35] = FB[98][12];
[dvTP,36] = FB[99][12];
[dvTP,37] = FB[100][12];
[dvTP,38] = FB[101][12];
[dvTP,39] = FB[102][12];
[dvTP,40] = FB[103][12];
[dvTP,41] = FB[104][12];
[dvTP,42] = FB[105][12];
[dvTP,43] = FB[106][12];
[dvTP,44] = FB[107][12];
[dvTP,45] = FB[108][12];
[dvTP,46] = FB[109][12];

(****************  AUTOMIXER ************************************)
[dvTP,50] = FB[1][12];//REAL FEEDBACK - THE 12TH BYTE HOLDS THE ZERO OR ONE (MUTE OR UNMUTE) STATE OF STATE VARIABLE
[dvTP,51] = FB[2][12];//INPUT MUTES
[dvTP,52] = FB[3][12];
[dvTP,53] = FB[4][12];
[dvTP,86] = FB[5][12];//MASTER MUTE
[dvTP,87] = FB[6][12];
[dvTP,88] = FB[7][12];//GROUP MUTE
[dvTP,89] = FB[8][12];
[dvTP,90] = FB[9][12];
[dvTP,91] = FB[10][12];
[dvTP,92] = FB[11][12];//AUX OUT MUTES
[dvTP,93] = FB[12][12];
[dvTP,94] = FB[13][12];
[dvTP,95] = FB[14][12];
[dvTP,54] = FB[15][12];//SOLO
[dvTP,55] = FB[16][12];
[dvTP,56] = FB[17][12];
[dvTP,57] = FB[18][12];

[dvTP,62] = FB[19][12];//AUTO
[dvTP,63] = FB[20][12];
[dvTP,64] = FB[21][12];
[dvTP,65] = FB[22][12];
[dvTP,66] = FB[23][12];//OVERRIDE
[dvTP,67] = FB[24][12];
[dvTP,68] = FB[25][12];
[dvTP,69] = FB[26][12];
[dvTP,70] = FB[110][12];//GROUP INPUT 1
[dvTP,71] = FB[111][12];
[dvTP,72] = FB[112][12];
[dvTP,73] = FB[113][12];
[dvTP,74] = FB[114][12];//GROUP INPUT 2
[dvTP,75] = FB[115][12];
[dvTP,76] = FB[116][12];
[dvTP,77] = FB[117][12];
[dvTP,78] = FB[118][12];//GROUP INPUT 3
[dvTP,79] = FB[119][12];
[dvTP,80] = FB[120][12];
[dvTP,81] = FB[121][12];
[dvTP,82] = FB[122][12];//GROUP INPUT 4
[dvTP,83] = FB[123][12];
[dvTP,84] = FB[124][12];
[dvTP,85] = FB[125][12];

(************************* MIXER **************************************)
[dvTP,100] = FB[130][12];//MIXER INPUT MUTES
[dvTP,101] = FB[131][12];
[dvTP,102] = FB[132][12];
[dvTP,103] = FB[133][12];
[dvTP,104] = FB[134][12];//MIXER SOLO
[dvTP,105] = FB[135][12];
[dvTP,106] = FB[136][12];
[dvTP,107] = FB[137][12];
[dvTP,108] = FB[138][12];//MIXER MASTER MUTE

(************************* INPUT_CARD *************************************)
[dvTP,110] = FB[139][10];//INPUT_CARD PHANTOM
[dvTP,111] = FB[140][10];
[dvTP,112] = FB[141][10];
[dvTP,113] = FB[142][10];

(************************* GAIN ***********************************)
[dvTP,115] = FB[143][12];//MUTE

(*********************** N GAIN *************************************)
[dvTP,116] = FB[144][12];
[dvTP,117] = FB[145][12];
[dvTP,118] = FB[146][12];
[dvTP,119] = FB[147][12];
[dvTP,120] = FB[148][12];
(*********************** SOURCE_SELECTOR *************************)
[dvTP,126] = FB[149][12] = 0;
[dvTP,126] = FB[149][12] = 1;
[dvTP,127] = FB[149][12] = 2;
[dvTP,128] = FB[149][12] = 3;
[dvTP,129] = FB[149][12] = 4;
[dvTP,130] = FB[149][12] = 5;
[dvTP,131] = FB[149][12] = 6;
[dvTP,132] = FB[149][12] = 7;
[dvTP,133] = FB[149][12] = 8;

(************************ SOURCE_MATRIX ****************************)
SMAT_FB = (SMAT_OUT-1);
[dvTP,135] = FB[SMAT_FB+150][12] = 1;
[dvTP,136] = FB[SMAT_FB+150][12] = 2;
[dvTP,137] = FB[SMAT_FB+150][12] = 3;
[dvTP,138] = FB[SMAT_FB+150][12] = 4;
[dvTP,139] = FB[SMAT_FB+150][12] = 5;
[dvTP,140] = FB[SMAT_FB+150][12] = 6;
[dvTP,141] = FB[SMAT_FB+150][12] = 7;
[dvTP,142] = FB[SMAT_FB+150][12] = 8;

(*********************** OUTPUT_CARD ***********************************)


(* FEEDBACK AFTER SUBSCRIBING TO A METER *)
IF(menuOUTPUTCARD)
{
    METER_FB =TYPE_CAST(MID_STRING(FB[158],10,1)); //FB[158] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO;FB[][10] HOLDS VALUE OF PERCENT
    SEND_LEVEL dvTP,63,METER_FB;
    
    METER_FB = TYPE_CAST(MID_STRING(FB[159],10,1)); //FB[159] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO;FB[][10] HOLDS VALUE OF PERCENT
    SEND_LEVEL dvTP,64,METER_FB;
}

(******************************** GAIN VOLUME  ********************************)
(* TO UPDATE VOLUME BAR GRAPHS WHEN USING A NON ACTIVE BAR GRAPH*) //SEE BUTTON_EVENT 13,14
(*IF USING SUBSCRIBE PERCENT!!!*)

MASTEROUT_VOL = TYPE_CAST(MID_STRING(FB[162],10,1)); //FB[162] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO
SEND_LEVEL dvTP, 42, MASTEROUT_VOL;




(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

